明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 2849|回复: 10

JIG应该怎么写这个功能,狐哥

[复制链接]
发表于 2009-9-30 15:11:00 | 显示全部楼层 |阅读模式
提示: 作者被禁止或删除 内容自动屏蔽
发表于 2009-9-30 23:54:00 | 显示全部楼层

基点Copy?

这个和其他的Jig没有什么不同,你先看下例子吧

 楼主| 发表于 2009-10-1 21:58:00 | 显示全部楼层
提示: 作者被禁止或删除 内容自动屏蔽
发表于 2009-10-1 23:32:00 | 显示全部楼层

没做过这样的:)不会是直接拖动XLine的吧?

发表于 2009-10-2 07:19:00 | 显示全部楼层
KO入行时间太短,AutoCAD十字标的长短是可以设置的。
 楼主| 发表于 2009-10-2 22:24:00 | 显示全部楼层
提示: 作者被禁止或删除 内容自动屏蔽
发表于 2009-10-2 22:37:00 | 显示全部楼层
不好意思,图没看仔细。
发表于 2009-10-2 23:35:00 | 显示全部楼层

XLine做应该是没有问题的,不知道有没更好的办法:)

有时间写个吧

国庆这两天休息太舒服了

发表于 2009-10-3 09:56:00 | 显示全部楼层
  1. using System;
  2. using System.Collections.Generic;
  3. using System.Text;
  4. using Autodesk.AutoCAD.EditorInput;
  5. using Autodesk.AutoCAD.DatabaseServices;
  6. using Autodesk.AutoCAD.Runtime;
  7. using Autodesk.AutoCAD.Geometry;
  8. using Autodesk.AutoCAD.ApplicationServices;
  9. [assembly: CommandClass(typeof(TlsCad.Jigs.TestJig1))]
  10. namespace TlsCad.Jigs
  11. {
  12.     public class TestJig1 : DrawJig
  13.     {
  14.         private Point3d _position;
  15.         private Xline _xline;
  16.         public TestJig1(Xline xline)
  17.         {
  18.             _xline = xline;
  19.         }
  20.         protected override bool WorldDraw(Autodesk.AutoCAD.GraphicsInterface.WorldDraw wd)
  21.         {
  22.             _xline.BasePoint = _position;
  23.             wd.Geometry.Draw(_xline);
  24.             return true;
  25.         }
  26.         protected override SamplerStatus Sampler(JigPrompts prompts)
  27.         {
  28.             JigPromptPointOptions jigOpts = new JigPromptPointOptions();
  29.             jigOpts.UserInputControls =
  30.                 UserInputControls.Accept3dCoordinates |
  31.                 UserInputControls.NoZeroResponseAccepted |
  32.                 UserInputControls.NoNegativeResponseAccepted;
  33.             jigOpts.Message = "\n请输入终点:";
  34.             jigOpts.Cursor = CursorType.EntitySelect;
  35.             PromptPointResult res = prompts.AcquirePoint(jigOpts);
  36.             if (res.Status == PromptStatus.OK)
  37.             {
  38.                 if (_position == res.Value)
  39.                 {
  40.                     return SamplerStatus.NoChange;
  41.                 }
  42.                 else
  43.                 {
  44.                     _position = res.Value;
  45.                     return SamplerStatus.OK;
  46.                 }
  47.             }
  48.             return SamplerStatus.Cancel;
  49.         }
  50.         [CommandMethod("tej")]
  51.         public static void DoIt()
  52.         {
  53.             Editor ed = Application.DocumentManager.MdiActiveDocument.Editor;
  54.             Xline xline = new Xline();
  55.             xline.BasePoint = Point3d.Origin;
  56.             xline.SecondPoint = Point3d.Origin + Vector3d.XAxis;
  57.             TestJig1 jig = new TestJig1(xline);
  58.             PromptResult var = ed.Drag(jig);
  59.             if (var.Status != PromptStatus.OK)
  60.             {
  61.                 return;
  62.             }
  63.         }
  64.     }
  65. }

 楼主| 发表于 2009-10-3 20:05:00 | 显示全部楼层
提示: 作者被禁止或删除 内容自动屏蔽
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-25 18:35 , Processed in 0.182469 second(s), 24 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表